﻿#pragma once

#include "..\..\DuiLib\UIlib.h"
#include "DuiDefine.h"
#include "UIListCommonDefine.hpp"

class MainFrame;
class CSettingFrame;

struct GroupItemInfo
{
	int  nGroupID;
	CString strGroupName;
	GroupItemInfo()
	{
		nGroupID = 0;
		strGroupName = _T("");
	}
};

class CSettingPersonal : public CContainerUI
{
public:
	CSettingPersonal(CSettingFrame* pSettingFrame, CPaintManagerUI& paint_manager);
	~CSettingPersonal();

	void CreateControl();
	void InitControl();
	void InitData();
	list<Node*> GetSelectedNodeList(CListUI* pList, BOOL bEnable = TRUE);
	Node* AddFavoriteNode(const GroupItemInfo &item, Node* parent, BOOL bInsertFirst = FALSE);
	Node* AddExportNode(const GroupItemInfo &item, Node* parent);
	Node* AddImportNode(const GroupItemInfo &item, Node* parent);
	void NotifyCtrlClick(TNotifyUI& msg);
	void NotifyTextChange(TNotifyUI& msg);
	void NotifyItemSelect(TNotifyUI& msg);
	void OnNotifyItemDoubleClick(TNotifyUI& msg);
	void ProcLabelEvent(CControlUI* pCtrl);
	void SetGroupType(int nGroupType);
	void EnableFavoriteList(bool bEnableNewFavorite, bool bEnableOldFavorite);
	void SaveFavoriteFile();
	BOOL FindInFavoriteList(CString strGroupName);
	const CString GetNewGroupName(const CString strDefaultName);
	void ImportFavoriteFile();
	bool RemoveFavoriteNode(Node* node);
	bool RemoveExportNode(Node* node);
	void RemoveAllMenberList(CListUI* pList);

	void ShowTimeCheckStatus();
	void EnableTimeCombo();
	void SetNameLength(int nLen);
	bool DoApply();
	
private:
	vector<CString> m_vecExportList;
	vector<GroupItemInfo> m_vecAddToFavorite;
	vector<IMPORT_GROUP> m_vecImportGroup;
	CListUI*	m_pListImport;
	CListUI*	m_pListExport;
	CListUI*	m_pListFavorite;
	int			m_nGroupType;
	bool		m_bTimeCheck;
	int			m_nAwayTimeSpin;
	Node*		m_pFavoriteRootNode;
	Node*		m_pExportRootNode;
	Node*		m_pImportRootNode;
	CPaintManagerUI& m_paintManager;
	CDialogBuilder  m_dlgBuilder;
	CSettingFrame*	m_pSettingFrame;	
};
